<?php /*

Diesel 1.0 installation script

install.php
Creation date/cr le: 15/11/2004
Written by/crit par Bigue Nique (BigueNique@yahoo.ca)
Copyright (C) 2004, Fiat+/Lux Media
This file is part of the Diesel Project.
Ce fichier fait partie du projet Diesel.

*/

$languages=array(
 array('code'=>'en','caption'=>'English'),
 array('code'=>'fr','caption'=>'Franais')
);

$diesel_title=array(
 'en'=>'Diesel 1.0 Installation',
 'fr'=>'Installation de Diesel 1.0'
);

$step_name = array(
 'error'=>array(
           'fr'=>'Erreur',
           'en'=>'Error'
          ),
 1=>'Select language',
 2=>array(
    'fr'=>'Information de connexion MySQL',
    'en'=>'MySQL login information'
   ),
 3=>array(
    'fr'=>'Slection de la base de donne',
    'en'=>'Database selection'
   ),
 4=>array(
    'fr'=>'Identification administrateur',
    'en'=>'Administrator identification'
   ),
 5=>array(
    'fr'=>'Installation de base termine',
    'en'=>'Basic installation done'
   )
 );

$text=array(
 'already_installed'=>array(
  'en'=>'Diesel is already installed. If you wish to re-run installation, please manually delete the file named .htaccess in the diesel/conf/ directory and reload this page.',
  'fr'=>'Diesel est dj install. Si vous dsirer rinstaller Diesel, veuillez effacer manuellement le fichier appel .htaccess dans le rpertoire diesel/conf/ et recharger cette page.'
 ),
 'submit_button'=>array(
  'en'=>'Next',
  'fr'=>'Poursuivre'
 ),
 'back_button'=>array(
  'en'=>'Back',
  'fr'=>'Retourner'
 ),
 'prompt_mysql_info'=>array(
  'en'=>'Please input the MySQL server connection information',
  'fr'=>'Veuillez entrer les informations de connexion au serveur MySQL'
 ),
 'mysql_address'=>array(
  'en'=>'Server address',
  'fr'=>'Adresse du serveur'
 ),
 'mysql_login'=>array(
  'en'=>'Login',
  'fr'=>'Identifiant de connexion'
 ),
 'mysql_password'=>array(
  'en'=>'Password',
  'fr'=>'Mot de passe'
 ),
 'mysql_connect_error'=>array(
  'en'=>'Connection to MySQL server has failed. Please go back and check provided information.',
  'fr'=>'La connection au serveur MySQL a chou. Veuiller vrifier les informations que vous avez fournies.'
 ),
 'mysql_listdb_warning'=>array(
  'en'=>'Warning: unable to list available databases',
  'fr'=>'Avertissement: impossible de lister les bases de donnes'
 ),
 'prompt_select_db'=>array(
  'en'=>'Please select the database you want Diesel to use. You can either select an existing database or create a new one.',
  'fr'=>'Veuillez slectionner la base de donne que Diesel utilisera. Vous pouvez utiliser une base existante ou en crer une nouvelle.'
 ),
 'db_create'=>array(
  'en'=>'Create a new database',
  'fr'=>'Crer une nouvelle base de donnes'
 ),
 'db_existing'=>array(
  'en'=>'Select an existing database',
  'fr'=>'Slectionner une base de donnes existante'
 ),
 'db_none'=>array(
  'en'=>'(No existing database found)',
  'fr'=>'(Aucune base de donne trouve)'
 ),
 'prompt_admin_id'=>array(
  'en'=>'Please enter the desired administrator login information.',
  'fr'=>'Veuillez entrer le login administrateur dsir.'
 ),
 'id_name'=>array(
  'en'=>'Display name',
  'fr'=>'Nom affich'
 ),
 'id_login'=>array(
  'en'=>'Your login',
  'fr'=>'Votre identifiant'
 ),
 'id_password'=>array(
  'en'=>'Password',
  'fr'=>'Mot de passe'
 ),
 'id_password_check'=>array(
  'en'=>'Repeat password',
  'fr'=>'Rptez le mot de passe'
 ),
 'pw_mismatch'=>array(
  'en'=>'Password mismatch. Please go baack and re-enter password',
  'fr'=>'Erreur de mot de passe. Veuiller rentrer le mot de passe.'
 ),
 'setup_done'=>array(
  'en'=>'Basic setup is now done sucessfully. You can now <a href="../../">browse your Diesel website</a>, login and get to the administrator section to fine-tune it.<br><br><b>NOTE:</b> if, for any reason, you wish to re-run Install, you\'ll need to delete the file named <i>.htaccess</i> located in the <i>diesel/setup/</i> directory.',
  'fr'=>'L\'installation de base est maintenant termine. Vous pouver maintenant accder <a href="../../"> votre site Diesel</a>, vous identifier et aller  la section administrateur pour en parfaire le rglage.<br><br><b>NOTE: </b> si, pour quelque raison que ce soit, vous dsirez rexcuter l\'installation, vous devrez d\'abord effacer manuellement le fichier nomm <i>.htaccess</i> situ dans le rpertoire <i>diesel/setup</i>.'
 ),
 'x'=>array(
  'en'=>'',
  'fr'=>''
 ),
 'end'
);

function lang($multilang_text, $language=null)
{
 global $lang;
 if (!$language) $language=$lang;
 if (is_array($multilang_text))
 {
  if (isset($multilang_text[$language]))
   $result=$multilang_text[$language];
  else
   if ($language!='en')
    $result=lang($multilang_text, 'en');
   else
    $result=$multilang_text;
 }
 else
   $result=$multilang_text;

 return $result;
}

// Conversion des paramtres passs en POST dans le formulaire prcdent

if (isset($_POST['step'])) $step=(int)$_POST['step']; else $step=1;
if (isset($_POST['lang'])) $lang=$_POST['lang']; else $lang='en';
if (isset($_POST['mysql_host'])) $mysql_host=$_POST['mysql_host'];
if (isset($_POST['mysql_login'])) $mysql_login=$_POST['mysql_login'];
if (isset($_POST['mysql_password'])) $mysql_password=$_POST['mysql_password'];
if (isset($_POST['db_name'])) $db_name=$_POST['db_name'];
if (isset($_POST['db_create'])) $db_create=$_POST['db_create'];
if (isset($_POST['id_name'])) $id_name=$_POST['id_name'];
if (isset($_POST['id_login'])) $id_login=$_POST['id_login'];
if (isset($_POST['id_password'])) $id_password=$_POST['id_password'];
if (isset($_POST['id_passwordcheck'])) $id_passwordcheck=$_POST['id_passwordcheck'];

?>
<html>
 <head>

  <title>
   <?php echo lang($diesel_title); ?>
  </title>

 </head>
 <body>
  <h1>
   <?php echo lang($diesel_title); ?>
  </h1>



<?php
// Excution de l'opration associe au formulaire de l'tape prcdente
// Si une erreur survient, on dfinit $success=false, $errormsg(string) $goback(bool)
echo '<pre>';
$success=true;

switch ($step-1)
{
case 0:
 // si la langue est donne en GET (dans la ligne de commande) on saute l'tape 1
 if (isset($_GET['lang']))
 {
  $lang=$_GET['lang'];
  $step+=1;
 }
 else break;
case 1: // Select language
 // rien  faire, lang est passe en POST
 break;
case 2: // MySQL server information
 // On essaie de se connecter au serveur
 // Si chec, on renvoie  l'tape prcdente.
 $db = mysql_connect($mysql_host,$mysql_login,$mysql_password) or $success=false;
 if (!$success)
 {
  $errormsg=lang($text['mysql_connect_error']);
  $goback=true;
 }
 break;
case 3: // Select/create db
 $db = mysql_connect($mysql_host,$mysql_login,$mysql_password) or $success=false;
 if (!$success)
 {
  $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().')<br>Unexpected Error (Fatal) - Could not connect twice to MySQL server';
  $goback=false;
 }
 else
 {
  if ($db_name=='!create')
  {
   $db_name=$db_create;
   if (!mysql_select_db($db_name)) // dont create if already exists!
   {
    mysql_query("CREATE DATABASE ".$db_name,$db) or $success=false;
    if (!$success)
    {
     $success=false;
     $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().')<br>Unable to create database. Please go back an try again.';
     $goback=true;
    }
   }
  }
  // select database
  if ($success)
   if (!mysql_select_db($db_name))
   {
    $success=false;
    $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().')<br>Unable to access specified database. Please go back an try again.';
    $goback=true;
   }
  // create file diesel/conf/mysql.conf
  if ($success)
   if (!($handle=fopen('../conf/mysql.conf','wb')))
   {
    $success=false;
    $errormsg='Unable to create file mysql.conf. Check server permissions and re-run install.';
    $goback=false;
   }
  if($success)
  {
   $success=fwrite($handle,
'<?php // Generated by diesel/install.php
 $mysql_host=\''.$mysql_host.'\';
 $mysql_login=\''.$mysql_login.'\';
 $mysql_password=\''.$mysql_password.'\';
 $mysql_diesel_database=\''.$db_name.'\';
?'.'>');
   fclose($handle);
   if (!$success)
   {
    $errormsg='Unable to write file mysql.conf. Check server permissions and re-run install.';
    $goback=false;
   }
  }
 }
 break;
case 4:
 $sql[1]['query'] =
<<<SQL
  CREATE TABLE `diesel_privilege_levels` (
   `id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
   `name` CHAR( 32 ) NOT NULL ,
   `permissions` TEXT NOT NULL ,
   PRIMARY KEY ( `id` ) ,
   UNIQUE ( `name` )
  ) COMMENT = 'Diesel 1.0 Permissions by Privilege Level';
SQL;
 $sql[1]['ignore']=1050; // dont stop if table already exists
 $adminpermissions=serialize(array('allow_siteadmin'=>true));
 $noadminpermissions=serialize(array('allow_siteadmin'=>false));
 $sql[2]['query'] = 'INSERT INTO `diesel_privilege_levels` ( `id` , `name` , `permissions` ) '
        . ' VALUES ( \'\', \'admin\', \''.$adminpermissions.'\' );';
 $sql[2]['ignore']=1062; // dont stop if entry already exists
 $sql[3]['query'] = 'INSERT INTO `diesel_privilege_levels` ( `id` , `name` , `permissions` ) '
        . ' VALUES ( \'\', \'superuser\', \''.$noadminpermissions.'\' );';
 $sql[3]['ignore']=1062; // dont stop if entry already exists
 $sql[4]['query'] = 'INSERT INTO `diesel_privilege_levels` ( `id` , `name` , `permissions` ) '
        . ' VALUES ( \'\', \'normal\', \''.$noadminpermissions.'\' );';
 $sql[4]['ignore']=1062; // dont stop if entry already exists
 $sql[5]['query'] = 'INSERT INTO `diesel_privilege_levels` ( `id` , `name` , `permissions` ) '
        . ' VALUES ( \'\', \'none\', \''.$noadminpermissions.'\' );';
 $sql[5]['ignore']=1062; // dont stop if entry already exists
 $sql[6]['query'] =
 <<<SQL
   CREATE TABLE `diesel_users` (
    `id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
    `login` CHAR( 32 ) NOT NULL ,
    `password` CHAR( 32 ) NOT NULL ,
    `displayname` CHAR( 32 ) NOT NULL ,
    `privileges` INT,
    `privileges_override` TEXT,
    `language` CHAR( 2 ) NOT NULL,
    `created` DATETIME,
    `lastlogin` DATETIME,
    `cookiename` CHAR( 32 ) ,
    `authentication` CHAR( 32 ) ,
    `expiration` DATETIME,
    PRIMARY KEY ( `id` ) ,
    UNIQUE ( `login` ) ) COMMENT = 'Diesel 1.0 Users Registry';
SQL;
 $sql[6]['ignore']=1050; // dont stop if table already exists
 $created=date('Y-m-d H:i:s');

 $sql[7]['query'] = 'INSERT INTO `diesel_users` ( `id` , `login` , `password` , `displayname` , `privileges` , `privileges_override` , `language` , `created` , `lastlogin` , `cookiename` , `authentication` , `expiration` ) '
        . ' VALUES ( \'\', \''.$id_login.'\', PASSWORD( \''.$id_password.'\' ) , \''.$id_name.'\', \'1\', NULL , \''.$lang.'\', \''.$created.'\', NULL , NULL , NULL , NULL );';
 $sql[7]['ignore']=1062; // dont stop if user entry already exists
 if ($success)
  if ($id_password!=$id_passwordcheck)
  {
   $success=false;
   $errormsg=lang($text['pw_mismatch']);
   $goback=true;
  }
 if ($success) // connect MySQL
 {
  include ('../conf/mysql.conf');
  $db = mysql_connect($mysql_host,$mysql_login,$mysql_password) or $success=false;
  if (!$success)
  {
   $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().')<br>Unexpected Error (Fatal) - Could not connect a third time to MySQL server';
   $goback=false;
  }
 }
 if ($success) // Select database
  if (!mysql_select_db($mysql_diesel_database))
  {
   $success=false;
   $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().')<br>Unable to access specified database. Please go back an try again.';
   $goback=true;
  }
 if ($success) // Execute queries
 {
  foreach($sql as $querynum => $querydef)
  {
   mysql_query($querydef['query'],$db) or $success=false;
   if (!$success)
    if (isset($querydef['ignore']))
     if (mysql_errno()==$querydef['ignore']) $success=true;
   if (!$success) break;
  }
  if (!$success)
  {
   $errormsg='(MySQL error #'.mysql_errno().': '.mysql_error().' in query #'.$querynum.')<br>Unable to create Diesel tables.<br>'.$sql[$querynum]['query'];
   $goback=false;
  }
 }
 if ($success)
  if (!($handle=fopen('.htaccess','wb')))
  {
   $success=false;
   $errormsg='Unable to create file .htaccess. Check server permissions and re-run install.';
   $goback=false;
  }
 if($success)
 {
  $success=fwrite($handle,'DENY FROM ALL');
  fclose($handle);
  if (!$success)
  {
   $errormsg='Unable to write file .htaccess. Check server permissions and re-run install.';
   $goback=false;
  }
 }
}

echo '</pre>';
echo '<table width="420" align="center" bgcolor="red" cellpadding="3" cellspacing="2"><tr><td bgcolor="white" valign="top">';
echo '<table width="100%" height="100%" bgcolor="yellow" cellpadding="10" cellspacing="2"><tr><td bgcolor="white" valign="top">';

if ($success)
{
 echo '<h3>'.$step.'. '.lang($step_name[$step]).'</h3>';
 echo '<form action="install.php" method="POST">';
 echo '<center>';

 switch($step)
 {
 // ============================================== STEP 1
 case 1: // Select language
  echo '<b>Select language for installation:</b><br><select name="lang">';
  foreach($languages as $l)
   echo '<option value="'.$l['code'].'">'.$l['caption'];
  echo '</select><br>';
  echo '<input type="hidden" name="step" value="2">';
  break;
 // ============================================== STEP 2
 case 2: // MySQL server information
  echo '<b>'.lang($text['prompt_mysql_info']).'</b>';
  echo '<br><table><tr><td>';
  echo lang($text['mysql_address']);
  echo '</td><td><input type="text" name="mysql_host" size="20" value="localhost"></td></tr><tr><td>';
  echo lang($text['mysql_login']);
  echo '</td><td><input type="text" name="mysql_login" size="20" value=""></td></tr><tr><td>';
  echo lang($text['mysql_password']);
  echo '</td><td><input type="password" name="mysql_password" size="20" value=""></td></tr></table>';
  echo '<input type="hidden" name="lang" value="'.$lang.'">';
  echo '<input type="hidden" name="step" value="3">';
  break;
 // ============================================== STEP 3
 case 3: // Select database
  $db_list = mysql_list_dbs($db) or $warning=lang($text['mysql_listdb_warning']);
  echo '<b>'.lang($text['prompt_select_db']).'</b>';
  echo '<br><br><table><tr><td colspan="2">';
  echo lang($text['db_create']);
  echo ' : </td></tr><tr><td><input type="radio" name="db_name" value="!create" checked></td><td>';
  echo '<input type="text" name="db_create" size="20" value="diesel"></td></tr><tr><td colspan="2">';
  echo lang($text['db_existing']);
  echo ' : </td></tr>';
  if ($db_list)
  {
   while ($row=mysql_fetch_object($db_list))
   {
    $db_name = $row->Database;
    if ($db_name=='diesel') $checked=' checked'; else $checked='';
    echo '<tr><td><input type="radio" name="db_name" value="'.$db_name.'"'.$checked.'></td><td>'.$db_name.'</td></tr>';
   }
  }
  else
  {
   echo '<tr><td>&nbsp;</td><td><font color="grey"><i>';
   if ($warning)
    echo $warning;
   else
    echo lang($text['db_no']);
   echo '</i></font></td></tr>';
  }
  echo '</table>';
  echo '<br>';
  echo '<input type="hidden" name="mysql_host" value="'.$mysql_host.'">';
  echo '<input type="hidden" name="mysql_login" value="'.$mysql_login.'">';
  echo '<input type="hidden" name="mysql_password" value="'.$mysql_password.'">';
  echo '<input type="hidden" name="lang" value="'.$lang.'">';
  echo '<input type="hidden" name="step" value="4">';
  mysql_free_result($db_list);
  break;
 // ============================================== STEP 3
 case 4: // Administrator identification
  echo '<b>'.lang($text['prompt_admin_id']).'</b>';
  echo '<br><table><tr><td>';
  echo lang($text['id_name']);
  echo '</td><td><input type="text" name="id_name" size="20"></td></tr><tr><td>';
  echo lang($text['id_login']);
  echo '</td><td><input type="text" name="id_login" size="20" value=""></td></tr><tr><td>';
  echo lang($text['id_password']);
  echo '</td><td><input type="password" name="id_password" size="20" value=""></td></tr><tr><td>';
  echo lang($text['id_password_check']);
  echo '</td><td><input type="password" name="id_passwordcheck" size="20" value=""></td></tr></table>';
  echo '<input type="hidden" name="lang" value="'.$lang.'">';
  echo '<input type="hidden" name="step" value="5">';
  break;
 case 5:
  echo lang($text['setup_done']);
  break;

 }
 if ($step < 5)
  echo '<input type="submit" value="'.lang($text['submit_button']).'">';
 echo '</center>';
}
else // $success=false
{
 echo '<h3><font color="red">'.lang($step_name['error']).'</font></h3>';
 echo '<form action="install.php" method="POST">';
 echo '<center>';
 echo $errormsg;
 echo '<br>';
 if ($goback)
 {
  echo '<input type="hidden" name="lang" value="'.$lang.'">';
  echo '<input type="hidden" name="step" value="'.($step-1).'">';
  if ($step==4)
  {
   echo '<input type="hidden" name="mysql_host" value="'.$mysql_host.'">';
   echo '<input type="hidden" name="mysql_login" value="'.$mysql_login.'">';
   echo '<input type="hidden" name="mysql_password" value="'.$mysql_password.'">';
  }
  echo '<input type="button" value="'.lang($text['back_button']).'" onClick="history.back();">';
  echo '</center>';
 }

}

echo '</form>';
echo '</tr></td></table>';
echo '</tr></td></table>';

?>

 </body>
</html>