<?php /*

Diesel 1.0 user library

diesel/user.php
Creation date/cr le: 10/12/2004
Written by/crit par Bigue Nique (BigueNique@yahoo.ca)
Copyright (C) 2004, Fiat+/Lux Media
This file is part of the Diesel Project.
Ce fichier fait partie du projet Diesel.

*/

// tweak pour cookies dans IE6...
header('P3P: CP="NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"');

function diesel_session_write()
{
 global $DIESEL, $DEBUG;

 $DIESEL['SESSION']['id']=$DIESEL['USER_ID'];

 $DEBUG->output('Session cookie with ID '.$DIESEL['USER_ID'].'...',__FILE__,__FUNCTION__,__LINE__);

 if (!setcookie($DIESEL['SESSION_COOKIE_NAME'],serialize($DIESEL['SESSION']),time()+$DIESEL['SESSION_COOKIE_LIFETIME']))
  $DEBUG->output('Unable to set session cookie',__FILE__,__FUNCTION__,__LINE__);
 else
  $DEBUG->output('Session cookie successfully set',__FILE__,__FUNCTION__,__LINE__);

}


function diesel_user_logout()
{
 global $DIESEL;

 if ($DIESEL['USER_ID']>0)
 {
  // Check if USER_ID is valid
  $query = 'SELECT * FROM `diesel_users` WHERE `id`='.$DIESEL['USER_ID'].' LIMIT 1;';
  $result = diesel_db_query($query);
  if ($user = mysql_fetch_object($result))
  {
   mysql_free_result($result);

   //delete cookie
   setcookie($user->cookiename, '', time()-1);
   $query='UPDATE `diesel_users` SET `cookiename` = NULL, `authentication` = NULL WHERE `id` = "'.$DIESEL['USER_ID'].'" LIMIT 1;';
   if (diesel_db_query($query))
   {
    $DIESEL['USER_ID']=0;
    $DIESEL['USER_DISPLAYNAME']=null;
    $DIESEL['USER_LOGIN']=null;
    diesel_session_write();
   }
  }
 }
}


function diesel_session_authenticate()
{
 global $DIESEL, $DEBUG;

 $authenticated = false;

 if ($DIESEL['USER_ID']==0)
 {
  $authenticated = true; // authentic visitor!
  $DEBUG->output('User 0, authentic visitor!', __FILE__, __FUNCTION__, __LINE__);
 }
 else
 {
  $DEBUG->output('User '.$DIESEL['USER_ID'].', need for authentication...', __FILE__, __FUNCTION__, __LINE__);
  $query='SELECT * FROM `diesel_users` WHERE `id`='.$DIESEL['USER_ID'].' LIMIT 1;';
  $result=diesel_db_query($query);
  if ($user = mysql_fetch_object($result)) // user exists
  {
   $DEBUG->output(' User ID found in DB (<b>'.$user->login.'</b>)', __FILE__, __FUNCTION__, __LINE__);
   if (isset($_COOKIE[$user->cookiename]))
   {
    $DEBUG->output(' Authentication cookie (<b>'.$user->cookiename.'</b>) FOUND!', __FILE__, __FUNCTION__, __LINE__);
    if ($_COOKIE[$user->cookiename]==$user->authentication)
    {
     $DEBUG->output(' User authenticated!', __FILE__, __FUNCTION__, __LINE__);
     $authenticated = true;
     // refresh cookie lifetime
     setcookie($user->cookiename,$user->authentication,time()+$DIESEL['AUTHENTICATION_COOKIE_LIFETIME']);
    }
    else
    {
     $DEBUG->output(' Authentication hash code mismatch.', __FILE__, __FUNCTION__, __LINE__);
    }
   }
   else
    $DEBUG->output(' Authentication cookie (<b>'.$user->cookiename.'</b>) <font color="red">NOT FOUND!</font>', __FILE__, __FUNCTION__, __LINE__);


  $DIESEL['USER_ID']=$user->id;
  $DIESEL['USER_DISPLAYNAME']=$user->displayname;
  $DIESEL['USER_LOGIN']=$user->login;
  }
  mysql_free_result($result);

 }

 if (!$authenticated)
 {
  $DEBUG->output(' <font color="red">Ending session</font>', __FILE__, __FUNCTION__, __LINE__);
  diesel_user_logout();
  echo('Failed to authenticate session in user.php. Session terminated');
 }


}


function diesel_session_recall()
{
 global $DIESEL, $DEBUG;

 $USER['id']=0; // default: user is visitor (not logged)

 if (isset($_COOKIE[$DIESEL['SESSION_COOKIE_NAME']]))
 {
  $cookie=unserialize(stripslashes($_COOKIE[$DIESEL['SESSION_COOKIE_NAME']]));
  if (isset($cookie['id'])) $USER['id'] = $cookie['id'];
  $DIESEL['SESSION']=$cookie;
  $DEBUG->output(' Session cookie found, '.$_COOKIE[$DIESEL['SESSION_COOKIE_NAME']], __FILE__, __FUNCTION__, __LINE__);

 }
 else
 {
  $DEBUG->output(' Session cookie <font color="red">NOT FOUND!</font>', __FILE__, __FUNCTION__, __LINE__);
  $cookie=null;
 }

 $DEBUG->output(' $USER[\'id\'] == '.$USER['id'], __FILE__, __FUNCTION__, __LINE__);
 $DEBUG->output(' $cookie[\'id\'] == '.$cookie['id'], __FILE__, __FUNCTION__, __LINE__);

 $DIESEL['USER_ID'] = $USER['id'];

 $DEBUG->output(' Auhtenticating User with ID '.$DIESEL['USER_ID'].'...', __FILE__, __FUNCTION__, __LINE__);
 diesel_session_authenticate();
 $DEBUG->output(' Leaving recall with ID '.$DIESEL['USER_ID'], __FILE__, __FUNCTION__, __LINE__);

}


function diesel_user_login($username, $password)
{
 global $DIESEL, $DEBUG;

 $query = 'SELECT * FROM `diesel_users` WHERE `login`="'.sqlsafe($username).'" AND password=PASSWORD("'.sqlsafe($password).'") LIMIT 1;';
 $result = diesel_db_query($query);
 if ($user = mysql_fetch_object($result))
 {
  $DEBUG->output('Login: User found in DB',__FILE__,__FUNCTION__,__LINE__);
  $DIESEL['USER_ID']=$user->id;
  $DIESEL['USER_DISPLAYNAME']=$user->displayname;
  $DIESEL['USER_LOGIN']=$user->login;
  $cookiename=md5(time());
  $authentication=md5(-time());
  $query='UPDATE `diesel_users` SET `cookiename` = "'.$cookiename.'", `authentication` = "'.$authentication.'", `lastlogin`=NOW() WHERE `id` = "'.$DIESEL['USER_ID'].'" LIMIT 1;';
  if (diesel_db_query($query))
  {
   if (!setcookie($cookiename,$authentication,time()+$DIESEL['AUTHENTICATION_COOKIE_LIFETIME']))
   {
    $DEBUG->html_dump();
    die('You must accept cookies to sign in! ;(');
    $success=false;
   }
   else
    $success=true;

   diesel_session_write();
  }
  else
   $success=false;
 }
 else
  $success=false;

 return $success;
}

function diesel_force_login($privilegeLevel=0)
{
 global $DIESEL;

 if ($DIESEL['USER_ID']==0)
 {
  echo '<script lang="javascript"><!--
         location.replace("'.$DIESEL['LOGINPAGE'].'?jumpback='.$_SERVER['PHP_SELF'].'");//--></script>';
  die('Redirection en cours... si la page ne s\'affiche pas <a href="'.$DIESEL['LOGINPAGE'].'?jumpback='.$_SERVER['PHP_SELF'].'">cliquez ici</a>');
 }
 if ($privilegeLevel!=0)
 {
  die('Cette fonctionnalit de diesel_require_login reste  dvelopper (USER.PHP)');
 }

}

?>